#include <stdio.h>
#include <stdlib.h>

int main (int argc, char ** argv) {

  int n, i, j, k;
  double ** a, ** b, ** c, * temp;

  if (argc != 2) {
    fprintf (stderr, "usage: %s N\n", argv[0]);
    return EXIT_FAILURE;
  } 

  if ( (n = atoi (argv[1])) < 0) {
    fprintf (stderr, "N must be gt 0\n");
    return EXIT_FAILURE;
  }

  srand (10);

  if ( (a = (double **) malloc (sizeof (double *) * n)) == NULL) {
    fprintf (stderr, "Memory allocation error\n");
    return EXIT_FAILURE;
  }
  else {
    if ( (temp = (double *) malloc (sizeof (double) * n * n)) == NULL) {
      fprintf (stderr, "Memory allocation error\n");
      return EXIT_FAILURE;
    }
    else {
      for (i=0; i<n; i++) 
        a[i] = &temp[i*n]; 
    }
  }

  if ( (b = (double **) malloc (sizeof (double *) * n)) == NULL) {
    fprintf (stderr, "Memory allocation error\n");
    return EXIT_FAILURE;
  }
  else {
    if ( (temp = (double *) malloc (sizeof (double) * n * n)) == NULL) {
      fprintf (stderr, "Memory allocation error\n");
      return EXIT_FAILURE;
    }
    else {
      for (i=0; i<n; i++) 
        b[i] = &temp[i*n]; 
    }
  }

  if ( (c = (double **) malloc (sizeof (double *) * n)) == NULL) {
    fprintf (stderr, "Memory allocation error\n");
    return EXIT_FAILURE;
  }
  else {
    if ( (temp = (double *) malloc (sizeof (double) * n * n)) == NULL) {
      fprintf (stderr, "Memory allocation error\n");
      return EXIT_FAILURE;
    }
    else {
      for (i=0; i<n; i++) 
        c[i] = &temp[i*n]; 
    }
  }

  for (i=0; i<n; i++) 
    for (j=0; j<n; j++)
      a[i][j] = 1.0e0 + (double) (1.0e0 * n * (rand() / (RAND_MAX + 1.0e0))); 

  fprintf (stdout, "\n");
  for (i=0; i<n; i++) {
    for (j=0; j<n; j++) {
      fprintf (stdout, "%10.5f ", a[i][j]);
    }
    fprintf (stdout, "\n");
  }

  for (i=0; i<n; i++) 
    for (j=0; j<n; j++)
      b[i][j] = 1.0e0 + (double) (1.0e0 * n * (rand() / (RAND_MAX + 1.0e0))); 

  fprintf (stdout, "\n");
  for (i=0; i<n; i++) {
    for (j=0; j<n; j++) {
      fprintf (stdout, "%10.5f ", b[i][j]);
    }
    fprintf (stdout, "\n");
  }

  for (i=0; i<n; i++) {
    for (j=0; j<n; j++) {
      c[i][j] = 0.0e0;
      for (k=0; k<n; k++) {
        c[i][j] = c[i][j] + (a[i][k] * b[k][j]);
      }
    }
  }

  fprintf (stdout, "\n");
  for (i=0; i<n; i++) {
    for (j=0; j<n; j++) {
      fprintf (stdout, "%10.5f ", c[i][j]);
    }
    fprintf (stdout, "\n");
  }

  fprintf (stdout, "\n%u %u \n", a[0], a);
  free (a[0]);
  free (a);

  fprintf (stdout, "%u %u \n", b[0], b);
  free (b[0]);
  free (b);

  fprintf (stdout, "%u %u \n", c[0], c);
  free (c[0]);
  free (c);

  return EXIT_SUCCESS;
}
